import inquirer from 'inquirer';
import fs from 'fs';
import ncp from 'ncp';
import path from 'path';
import editJsonFile from 'edit-json-file';
import appRootPath from "./path.cjs";
const __dirname = path.resolve();

export const getProjectName = () => {
  const projectName = process.argv[2];
  if(!projectName) {
    console.log('프로젝트명을 입력해주세요.');
    process.exit();
  }
  return projectName;
}

export const getPackageJson = (projectName) => {
  const packagePath = path.join(__dirname, projectName, '/package.json');
  const packageJson = editJsonFile(packagePath);
  return packageJson;
}

export const getSelectedType = async (projectName) => {
  const dirPath = path.join(appRootPath, '/libs/')
  const choices = fs.readdirSync(dirPath).filter((dir) => dir !== 'default');
  const questions = {
    type:'checkbox',
    name:"type",
    message:`${projectName} 프로젝트에 필요한 기능을 선택해주세요.\n`,
    choices,
    pageSize:10,
  }
  const { type = [] } = await inquirer.prompt(questions);
  return type;
}
export const copyProjectFiles = async (destination) => {
  return new Promise((resolve, reject) => {
    const source = path.join(appRootPath, './libs/default');
    const options = {
      clobber: true,
      stopOnErr: true,
    };

    ncp.limit = 16;
    ncp(source, destination, options, function (err) {
      if (err) reject(err);
      resolve();
    });
  });
};